/*
 * ctrlPoly.java
 *
 * Created on December 28, 2004, 7:46 PM
 */

package polys;

import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;
import javax.imageio.*;
import javax.swing.*;

/**
 *
 * @author  bob
 */
public class ctrlPoly extends javax.swing.JFrame {

    J3Dviewer theViewer;  // remember viewer so can send it messages
    int iPoly;            // our index in array
    xyz[][] bases;        // array of Frenet frames
    int nSides;           // # sides per polygon
    Vector triVec = new Vector();    // triangles for our polys
    final float tau = (float) ((1.0 + Math.sqrt(5.0)) / 2.0);
    final float tau2 = tau*tau;      // tau squared for dodec vertices
    int butt = 0;         // radio button selected
    private JFileChooser pngFileChooser = new JFileChooser();
    
    /** Creates new form ctrlPoly */
    public ctrlPoly(J3Dviewer viewer, int i) {
        theViewer = viewer;
        iPoly = i;
        initComponents();
        title.setText("Poly Controller #" + iPoly);
        this.show();
        basis6of4();       // initially cubelike
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        title = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        butt1 = new javax.swing.JRadioButton();
        butt2 = new javax.swing.JRadioButton();
        butt3 = new javax.swing.JRadioButton();
        butt4 = new javax.swing.JRadioButton();
        butt5 = new javax.swing.JRadioButton();
        jPanel4 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        inoutSlider = new javax.swing.JSlider();
        inoutLabel = new javax.swing.JLabel();
        jPanel5 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        lengthSlider = new javax.swing.JSlider();
        lengthLabel = new javax.swing.JLabel();
        jPanel8 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        widthSlider = new javax.swing.JSlider();
        widthLabel = new javax.swing.JLabel();
        jPanel7 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        thicknessSlider = new javax.swing.JSlider();
        thicknessLabel = new javax.swing.JLabel();
        jPanel6 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        rotateSlider = new javax.swing.JSlider();
        rotateLabel = new javax.swing.JLabel();
        jPanel9 = new javax.swing.JPanel();
        png = new javax.swing.JButton();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        jPanel1.setLayout(new java.awt.GridLayout(0, 1));

        title.setFont(new java.awt.Font("MS Sans Serif", 1, 12));
        title.setText("(not Initialized)");
        jPanel2.add(title);

        jPanel1.add(jPanel2);

        butt1.setText("Cube");
        butt1.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                butt1StateChanged(evt);
            }
        });

        jPanel3.add(butt1);

        butt2.setText("Tetra");
        butt2.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                butt2StateChanged(evt);
            }
        });

        jPanel3.add(butt2);

        butt3.setText("Octa");
        butt3.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                butt3StateChanged(evt);
            }
        });

        jPanel3.add(butt3);

        butt4.setText("Dodeca");
        butt4.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                butt4StateChanged(evt);
            }
        });

        jPanel3.add(butt4);

        butt5.setText("Icosa");
        butt5.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                butt5StateChanged(evt);
            }
        });

        jPanel3.add(butt5);

        jPanel1.add(jPanel3);

        jLabel2.setText("in/out");
        jPanel4.add(jLabel2);

        inoutSlider.setMaximum(1000);
        inoutSlider.setValue(600);
        inoutSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                inoutSliderStateChanged(evt);
            }
        });

        jPanel4.add(inoutSlider);

        inoutLabel.setText("-----");
        jPanel4.add(inoutLabel);

        jPanel1.add(jPanel4);

        jLabel3.setText("length");
        jPanel5.add(jLabel3);

        lengthSlider.setMaximum(1000);
        lengthSlider.setValue(600);
        lengthSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                lengthSliderStateChanged(evt);
            }
        });

        jPanel5.add(lengthSlider);

        lengthLabel.setText("-----");
        jPanel5.add(lengthLabel);

        jPanel1.add(jPanel5);

        jLabel1.setText("width");
        jPanel8.add(jLabel1);

        widthSlider.setMaximum(1000);
        widthSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                widthSliderStateChanged(evt);
            }
        });

        jPanel8.add(widthSlider);

        widthLabel.setText("-----");
        jPanel8.add(widthLabel);

        jPanel1.add(jPanel8);

        jLabel5.setText("thick");
        jPanel7.add(jLabel5);

        thicknessSlider.setMaximum(1000);
        thicknessSlider.setValue(10);
        thicknessSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                thicknessSliderStateChanged(evt);
            }
        });

        jPanel7.add(thicknessSlider);

        thicknessLabel.setText("-----");
        jPanel7.add(thicknessLabel);

        jPanel1.add(jPanel7);

        jLabel4.setText("rotate");
        jPanel6.add(jLabel4);

        rotateSlider.setMaximum(1200);
        rotateSlider.setValue(0);
        rotateSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                rotateSliderStateChanged(evt);
            }
        });

        jPanel6.add(rotateSlider);

        rotateLabel.setText("-----");
        jPanel6.add(rotateLabel);

        jPanel1.add(jPanel6);

        png.setText("export layout to .png file");
        png.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                pngActionPerformed(evt);
            }
        });

        jPanel9.add(png);

        jPanel1.add(jPanel9);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void rotateSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_rotateSliderStateChanged
        updateGeom();
    }//GEN-LAST:event_rotateSliderStateChanged

    private void pngActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_pngActionPerformed
        writeTemplate();            // output png file to print, cut, assemble
    }//GEN-LAST:event_pngActionPerformed

    private void widthSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_widthSliderStateChanged
        updateGeom();
    }//GEN-LAST:event_widthSliderStateChanged

    private void butt5StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_butt5StateChanged
        if (butt5.isSelected()) butt = 5;
        basis20of3();                   // icosahedron
        updateGeom();
    }//GEN-LAST:event_butt5StateChanged

    private void butt4StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_butt4StateChanged
        if (butt4.isSelected()) butt = 4;
        basis12of5();                   // dodecahedron
        updateGeom();   
    }//GEN-LAST:event_butt4StateChanged

    private void butt3StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_butt3StateChanged
        if (butt3.isSelected()) butt = 3;
        basis8of3();                   // octahedron
        updateGeom();
    }//GEN-LAST:event_butt3StateChanged

    private void butt2StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_butt2StateChanged
        if (butt2.isSelected()) butt = 2;
        basis4of3();                   // tetrahedron
        updateGeom();
    }//GEN-LAST:event_butt2StateChanged

    private void butt1StateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_butt1StateChanged
        if (butt1.isSelected()) butt = 1;
        basis6of4();                   // cube
        updateGeom();
    }//GEN-LAST:event_butt1StateChanged

    private void thicknessSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_thicknessSliderStateChanged
        updateGeom();
    }//GEN-LAST:event_thicknessSliderStateChanged

    private void lengthSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_lengthSliderStateChanged
        updateGeom();
    }//GEN-LAST:event_lengthSliderStateChanged

    private void inoutSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_inoutSliderStateChanged
        updateGeom();
    }//GEN-LAST:event_inoutSliderStateChanged
    
    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm

    public double getLength(){                        // Length, from slider
        return lengthSlider.getValue()/100.0;
    }

    public double getInout(){            // dist of plane from origin, from slider
        if ((butt==4 || butt==5) && inoutSlider.getValue()==0)
            rotateSlider.setValue(900);         // special fusing together
        return inoutSlider.getValue()/100.0;
    }

    public double getThickness(){                     // thickness, from slider
        return thicknessSlider.getValue()/100.0;
    }

    public double getwidth(){                     // width, from slider
        return widthSlider.getValue()/100.0;
    }

    public double getRotate(){     // rotation.    Convert 0.1 deg units to radians
        return -Math.PI * rotateSlider.getValue()/(180 * 10.0);
    }

    public void updatePanel(){
        butt1.setSelected(butt==1);     // ensure only one button set
        butt2.setSelected(butt==2);
        butt3.setSelected(butt==3);
        butt4.setSelected(butt==4);
        butt5.setSelected(butt==5);        
        inoutLabel.setText(new Float(getInout()).toString());
        lengthLabel.setText(new Float(getLength()).toString());
        widthLabel.setText(new Float(getwidth()).toString());
        thicknessLabel.setText(new Float(getThickness()).toString());
        rotateLabel.setText(new Float(-180.0f * getRotate() / Math.PI).toString());
    }
    
    private void basis6of4(){          // make 6 squares, based on cube
        xyz up = new xyz( 0, 0, 1);    // normal directions
        xyz rt = new xyz( 1, 0, 0);
        xyz fd = new xyz( 0, 1, 0);
        bases = makeBases(new xyz[][] {{rt, fd}, {fd, up}, {up, rt}}, true);
        nSides = 4;                      // each poly is a square
    }

    private void basis4of3(){                    // make 4 triangles
        xyz v1 = new xyz( 1, 1, 1);              // cube corner directions
        xyz v2 = new xyz(-1,-1, 1);
        xyz v3 = new xyz(-1, 1,-1);
        xyz v4 = new xyz( 1,-1,-1);
        bases = makeBases(new xyz[][] {{v1, v2}, {v2, v3}, {v3, v4}, {v4, v1}}, false);
        nSides = 3;                               // each a triangle
    }
    
    private void basis8of3(){                    // make 8 triangles
        xyz v1 = new xyz( 1, 1, 1);              // cube corner directions
        xyz v2 = new xyz(-1,-1, 1);
        xyz v3 = new xyz(-1, 1,-1);
        xyz v4 = new xyz( 1,-1,-1);
        bases = makeBases(new xyz[][] {{v1, v2}, {v2, v3}, {v3, v4}, {v4, v1}}, true);
        nSides = 3;                               // each a triangle
    }
    
//    private void  basis12of5(){                  // make 12 pentagons, dodecahedron
//        xyz v1 = new xyz( tau, 1.0f, 0.0f);
//        xyz v2 = new xyz( tau,-1.0f, 0.0f);
//        xyz v3 = new xyz( 1.0f, 0.0f, tau);
//        xyz v4 = new xyz(-1.0f, 0.0f, tau);
//        xyz v5 = new xyz( 0.0f, tau, 1.0f);
//        xyz v6 = new xyz( 0.0f, tau,-1.0f);
//        bases = makeBases(new xyz[][] {{v1,v2}, {v2,v1}, {v3,v4},
//                                       {v4,v3}, {v5,v6}, {v6,v5}}, true);
//        nSides = 5;
//    }
    
    private void  basis12of5(){                  // make 12 pentagons, dodecahedron
        xyz v1 = new xyz( 1.0f, tau, 0.0f);
        xyz v2 = new xyz(-1.0f, tau, 0.0f);
        xyz v3 = new xyz(0.0f, 1.0f, tau);
        xyz v4 = new xyz(0.0f,-1.0f, tau);
        xyz v5 = new xyz(tau, 0.0f, 1.0f);
        xyz v6 = new xyz(tau, 0.0f,-1.0f);
        bases = makeBases(new xyz[][] {{v1,v2}, {v2,v1}, {v3,v4},
                                       {v4,v3}, {v5,v6}, {v6,v5}}, true);
        nSides = 5;
    }
    
    private void  basis20of3(){                  // make 20 triangles, icosahedron
        xyz v1 = new xyz( tau2, 1.0f, 0.0f);     // dodec vertices for normals
        xyz v2 = new xyz( tau2,-1.0f, 0.0f);
        xyz v3 = new xyz( 0.0f, tau2, 1.0f);
        xyz v4 = new xyz( 0.0f, tau2,-1.0f);
        xyz v5 = new xyz( 1.0f, 0.0f, tau2);
        xyz v6 = new xyz(-1.0f, 0.0f, tau2);
        xyz v7 = new xyz( 1.0f, 1.0f, 1.0f);
        xyz v8 = new xyz(-1.0f, 1.0f, 1.0f);
        xyz v9 = new xyz(-1.0f,-1.0f, 1.0f);
        xyz v0 = new xyz( 1.0f,-1.0f, 1.0f);
        bases = makeBases(new xyz[][] 
           {{v1,v2}, {v2,v1}, {v3,v4}, {v4,v3}, {v5,v6}, {v6,v5},
            {v7,v5}, {v8,v6}, {v9,v6}, {v0,v5}}, true);
        nSides = 3;
    }
    
    // create Frenet frames from vector pairs, by Graham-Schmitt process. 
    // optionally make 2nd half as opposite first half
    private xyz[][]makeBases (xyz[][] dir, boolean centralSymmetry){
        int nIn = dir.length;                  // input {{normal dir, start dir}, ...}
        int nOut = nIn;                        // output {{basis}, {basis}, ...}
        if (centralSymmetry) nOut = 2*nIn;     // input just half if true
        xyz[][] ans = new xyz[nOut][3];        // create orthonormal bases
        for (int i=0; i<nIn; i++){
            xyz v1 = xyz.unit(dir[i][0]);      // Graham-Schmitt
            xyz v2 = xyz.unit(xyz.minus(dir[i][1], xyz.scale(xyz.dot(v1,dir[i][1]),v1)));
            xyz v3 = xyz.cross(v1,v2);
            ans[i] = new xyz[] {v1, v2, v3};
            if (centralSymmetry) ans[i+nIn] = new xyz[] {xyz.neg(v1), xyz.neg(v2), v3};
        }
        return ans;
    }
    
    // create set of triangles to bound the 3D objects
    private void updateGeom(){ 
        updatePanel();             //something changed, so update labels
        triVec = new Vector();
        double r1 = getLength()/(2.0 * Math.sin(Math.PI/nSides));
        double dist = r1 * Math.cos(Math.PI/nSides);   // poly inradius
        double beta = (dist-getwidth()) / dist;        // r2/r1 ratio
        if (beta < 0.0) beta = 0.0;
        double theta0 = getRotate();
        double thetan = 2.0 * Math.PI / nSides;
        for (int k=0; k<bases.length; k++){   // for each polygon:
            xyz out1 = xyz.scale(getInout() + getThickness(), bases[k][0]);
            xyz out2 = xyz.scale(getInout(), bases[k][0]);
            if ((butt==4 || butt==5) && inoutSlider.getValue()==0) out2 = xyz.neg(out1);
            xyz[] v1 = new xyz[nSides];           // outer vertices
            xyz[] v2 = new xyz[nSides];           // inner vertices
            for (int i=0; i<nSides; i++){                
                v1[i] = xyz.plus(xyz.scale(r1*Math.cos(theta0 + i*thetan), bases[k][1]),
                                 xyz.scale(r1*Math.sin(theta0 + i*thetan), bases[k][2]));
                v2[i] = xyz.scale(beta, v1[i]);   // scale to r2
            }
            for (int i=0; i<nSides; i++){                           // create triangles: 
                tri t1 = new tri(v1[i], v1[(i+1)%nSides], v2[i]);   // outside surface
                triVec.add(t1.offset(out1));
                triVec.add(t1.offset(out2).reverse());
                
                tri t2 = new tri(v2[i], v1[(i+1)%nSides], v2[(i+1)%nSides]);  // inside
                triVec.add(t2.offset(out1));
                triVec.add(t2.offset(out2).reverse());
                
                addEdge(triVec, v1[i], v1[(i+1)%nSides], out2, out1);     // outer edges
                addEdge(triVec, v2[i], v2[(i+1)%nSides], out1, out2);     // inner edges           
            }
            //skip second overlaying half if planes brought to center
            if ((butt==4 || butt==5) && inoutSlider.getValue()==0 && k==bases.length/2-1) break;
        }
        theViewer.updateGeometry();
    }


    // make 2 trianges forming rectangle along one polygon's inner or outer edge
    private void addEdge(Vector vec, xyz end1, xyz end2, xyz off1, xyz off2){
        xyz v1 = xyz.plus(end1, off1);
        xyz v2 = xyz.plus(end2, off1);
        xyz v3 = xyz.plus(end1, off2);
        xyz v4 = xyz.plus(end2, off2);
        vec.add(new tri(v1, v2, v4));
        vec.add(new tri(v4, v3, v1));      //note handedness
    }
    
    // output .png file with template to print and cut out
    private void writeTemplate(){
      try{           
        if (pngFileChooser.showSaveDialog(null) != JFileChooser.APPROVE_OPTION )
            return;
        String pngFileName = pngFileChooser.getSelectedFile().getPath();
        pngFileName = J3Dviewer.forceExtension(pngFileName, "png");   // annex .png if user didn't
        File pngFile = new File(pngFileName);
       
        int w = 800;                         //  Create image.  8x10.5 in   100 pixels/inch
        int h = 1050;                        //  width and height
        double scale = 100.0;                // convert coords to pixels
        BufferedImage img = (BufferedImage) createImage(w, h);  
        Graphics2D imgG = img.createGraphics();
        imgG.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        imgG.setColor(Color.white);                     // clear rectangle
        imgG.fill(new Rectangle(0,0,w,h));
        imgG.setColor(Color.black);
        imgG.setStroke(new BasicStroke(0.5f));          // line thickness
        //imgG.setPaint(Color.black);
        
        //imgG.draw(new Line2D.Double(10,200,30,40));
        
        double r1 = getLength()/(2.0 * Math.sin(Math.PI/nSides));  // circumradius
        double dist = r1 * Math.cos(Math.PI/nSides);               // inradius
        double beta = (dist-getwidth()) / dist;                    // r2/r1 ratio
        if (beta < 0.0) beta = 0.0;
        double thetan = 2.0 * Math.PI / nSides;
        double theta0 = 0.0;                                       // angle offset
        if (nSides==4) theta0 = Math.PI / 4;     // align square to sides of paper
        if (nSides==3) theta0 = Math.PI / 6;     // align tri to fit best in paper
        double[] x1 = new double[nSides];                           // outer vertices
        double[] y1 = new double[nSides];
        double[] x2 = new double[nSides];                           // inner vertices
        double[] y2 = new double[nSides];
        for (int i=0; i<nSides; i++){                               // calc coords
             x1[i] = scale * r1 * Math.cos(i*thetan + theta0) + w/2.0;
             y1[i] = scale * r1 * Math.sin(i*thetan + theta0) + h/2.0;
             x2[i] = beta * (x1[i]-w/2.0) + w/2.0;
             y2[i] = beta * (y1[i]-h/2.0) + h/2.0;
            }
        for (int i=0; i<nSides-1; i++){
            imgG.draw(new Line2D.Double(x1[i], y1[i], x1[i+1], y1[i+1]));
            imgG.draw(new Line2D.Double(x2[i], y2[i], x2[i+1], y2[i+1]));
        }
        imgG.draw(new Line2D.Double(x1[nSides-1], y1[nSides-1], x1[0], y1[0]));  // close loop
        imgG.draw(new Line2D.Double(x2[nSides-1], y2[nSides-1], x2[0], y2[0]));

        double right = scale * getLength();                 // one rectangle side
        double bottom = scale * getThickness();
        imgG.draw(new Line2D.Double(0.0, 0.0,  right, 0.0));
        imgG.draw(new Line2D.Double(0.0, bottom, right, bottom));  
        imgG.draw(new Line2D.Double(0.0, 0.0, 0.0, bottom));  
        imgG.draw(new Line2D.Double(right, 0.0, right, bottom));  
                
        ImageIO.write(img, "png", pngFile);
      }
      catch(Exception ex){
        System.out.println("Error writing file");
        return;
        }

    }
    
    /**
     * @param args the command line arguments
     */
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton butt1;
    private javax.swing.JRadioButton butt2;
    private javax.swing.JRadioButton butt3;
    private javax.swing.JRadioButton butt4;
    private javax.swing.JRadioButton butt5;
    private javax.swing.JLabel inoutLabel;
    private javax.swing.JSlider inoutSlider;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JLabel lengthLabel;
    private javax.swing.JSlider lengthSlider;
    private javax.swing.JButton png;
    private javax.swing.JLabel rotateLabel;
    private javax.swing.JSlider rotateSlider;
    private javax.swing.JLabel thicknessLabel;
    private javax.swing.JSlider thicknessSlider;
    private javax.swing.JLabel title;
    private javax.swing.JLabel widthLabel;
    private javax.swing.JSlider widthSlider;
    // End of variables declaration//GEN-END:variables
    
}
