/*
 * tri.java
 *
 * Created on December 28, 2004, 6:07 PM
 */

package polys;

/**
 * thin container for three vertices
 * @author  gwh
 */
public class tri {
    
    public xyz v1, v2, v3;                     //extract as .v1  .v2 or .v3
    
    public tri(xyz vertex1, xyz vertex2, xyz vertex3) {     //constructor
        v1=vertex1;
        v2=vertex2;
        v3=vertex3;
    }
    
    public xyz normal(){                   // unit normal orthogonal to plane
        return xyz.unit(xyz.cross(xyz.minus(v2,v1), xyz.minus(v3,v1)));

    }
    
    public tri scale(double alpha){        // scale relative to origin
        return new tri(xyz.scale((float)alpha, v1),
                       xyz.scale((float)alpha, v2),
                       xyz.scale((float)alpha, v3));
    }
    
    public tri offset(xyz delta){          //translate
        return new tri(xyz.plus(delta, v1),
                       xyz.plus(delta, v2),
                       xyz.plus(delta, v3));
    }
 
    public tri reverse(){                  // face other direction
        return new tri(v1, v3, v2);
    }
}
